<template>
    <v-row>
        <v-col>
            <product-form
                v-model="product"
                :loading="loading"
                :clearable="false"
                @updated="onUpdate"
                mode="edit"
            >
            </product-form>
        </v-col>
    </v-row>
</template>

<script>
    import ProductForm from "./ProductForm";
    import util from "../../../mixins/util";

    export default {
        name: "ProductEdit",
        components: {ProductForm},
        mixins: [ util ],
        props: {
            id: [String, Number],
        },
        data: () => ({
            loading: true,
            product: {
                id: 0,
                name: '',
                description: '',
                sku: null,
                price: 0,
                cost_price: 0,
                images: [],
                deleted_images: [],
                uploaded_images: [],
                category_ids: [],
                gender_id: null,
                brand_id: null,
                business_type_id: null,
                product_type_id: null,
                variants: [],
                new_arrival:0,
                most_popular: 0,
                featured: 0,
                enabled: 0,
                vendor: null
            },
        }),

        mounted() {
            this.fetchProduct()
                .then(data => {
                    this.mapProduct(data);
                    this.loading = false;
                })
        },

        methods: {
            fetchProduct() {
                return new Promise((resolve, reject) => {
                    axios.get(`api/product/${this.id}`)
                        .then(({ data }) => {
                            resolve(data);
                        })
                        .catch(error => {
                            reject(error);
                        })
                })
            },

            mapProduct(product) {
                this.product.id = product.id;
                this.product.name = product.name;
                this.product.description = product.description;
                this.product.sku = product.sku;
                this.product.price = this.pricing(product.pricing).price;
                this.product.cost_price = this.pricing(product.pricing).cost_price;
                this.product.category_ids = _.map(product.categories, 'id');
                this.product.gender_id = product.gender.id;
                this.product.brand_id = product.brand.id;
                this.product.business_type_id = product.business_type.id;
                this.product.business_type_name = product.business_type.name;
                this.product.product_type_id = product.type.id;
                this.product.variants = product.variants;
                this.product.new_arrival = product.new_arrival ? 1 : 0;
                this.product.most_popular = product.most_popular ? 1 : 0;
                this.product.featured = product.featured ? 1 : 0;
                this.product.enabled = product.enabled ? 1 : 0;
                this.product.images = [];
                this.product.uploaded_images = product.images;
            },

            onUpdate(product) {
                this.mapProduct(product);
            }
        }
    }
</script>

<style >

</style>
